# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from squirrel_person_tracker_msgs/SkeletonJoint.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class SkeletonJoint(genpy.Message):
  _md5sum = "a8a2f36f4ea8aac6128fd48cb9ac46d6"
  _type = "squirrel_person_tracker_msgs/SkeletonJoint"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """geometry_msgs/TransformStamped joint
float32 orientation_confidence
float32 position_confidence
================================================================================
MSG: geometry_msgs/TransformStamped
# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href="http://www.ros.org/wiki/tf">tf</a> package. 
# See its documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['joint','orientation_confidence','position_confidence']
  _slot_types = ['geometry_msgs/TransformStamped','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       joint,orientation_confidence,position_confidence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SkeletonJoint, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.joint is None:
        self.joint = geometry_msgs.msg.TransformStamped()
      if self.orientation_confidence is None:
        self.orientation_confidence = 0.
      if self.position_confidence is None:
        self.position_confidence = 0.
    else:
      self.joint = geometry_msgs.msg.TransformStamped()
      self.orientation_confidence = 0.
      self.position_confidence = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.joint.header.seq, _x.joint.header.stamp.secs, _x.joint.header.stamp.nsecs))
      _x = self.joint.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.joint.child_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d2f.pack(_x.joint.transform.translation.x, _x.joint.transform.translation.y, _x.joint.transform.translation.z, _x.joint.transform.rotation.x, _x.joint.transform.rotation.y, _x.joint.transform.rotation.z, _x.joint.transform.rotation.w, _x.orientation_confidence, _x.position_confidence))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.joint is None:
        self.joint = geometry_msgs.msg.TransformStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.joint.header.seq, _x.joint.header.stamp.secs, _x.joint.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.joint.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint.child_frame_id = str[start:end].decode('utf-8')
      else:
        self.joint.child_frame_id = str[start:end]
      _x = self
      start = end
      end += 64
      (_x.joint.transform.translation.x, _x.joint.transform.translation.y, _x.joint.transform.translation.z, _x.joint.transform.rotation.x, _x.joint.transform.rotation.y, _x.joint.transform.rotation.z, _x.joint.transform.rotation.w, _x.orientation_confidence, _x.position_confidence,) = _struct_7d2f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.joint.header.seq, _x.joint.header.stamp.secs, _x.joint.header.stamp.nsecs))
      _x = self.joint.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.joint.child_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d2f.pack(_x.joint.transform.translation.x, _x.joint.transform.translation.y, _x.joint.transform.translation.z, _x.joint.transform.rotation.x, _x.joint.transform.rotation.y, _x.joint.transform.rotation.z, _x.joint.transform.rotation.w, _x.orientation_confidence, _x.position_confidence))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.joint is None:
        self.joint = geometry_msgs.msg.TransformStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.joint.header.seq, _x.joint.header.stamp.secs, _x.joint.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.joint.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint.child_frame_id = str[start:end].decode('utf-8')
      else:
        self.joint.child_frame_id = str[start:end]
      _x = self
      start = end
      end += 64
      (_x.joint.transform.translation.x, _x.joint.transform.translation.y, _x.joint.transform.translation.z, _x.joint.transform.rotation.x, _x.joint.transform.rotation.y, _x.joint.transform.rotation.z, _x.joint.transform.rotation.w, _x.orientation_confidence, _x.position_confidence,) = _struct_7d2f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_7d2f = struct.Struct("<7d2f")
_struct_3I = struct.Struct("<3I")
